<?php

require_once ("../../../config/config.php");
require_once (SITEROOT . '/class/include.class.php');

$me = new User();

if (!$me->authenticate()) {
	$_SESSION["error"] = "chec de l'authentification";
	header("Location: " . WEBSITE);
	exit ();
}

if (!$me->isSuper()) {
	$_SESSION["error"] = "Accs refus";
	header("Location: " . WEBSITE_SSL);
	exit ();
}

$id = isset ($_GET["id"]) ? $_GET["id"] : null;

$mod = false;
$zeModule = new Module();

if (isset ($id) && !empty ($id)) {
  $zeModule->setId($id);
  if ($zeModule->init()) {
	$mod = true;
  }
}

if (! $mod) {
  $_SESSION["error"] = "Pas d'identifiant de module spcifi.";
  header("Location: " . WEBSITE_SSL . "/admin/modules/admin_modules.php");
  exit();
}

$doc = new HTMLLayout();

$doc->addHeader("<script src=\"/" . WEBSITE_SSL . "/javascript/validateform.js\" type=\"text/javascript\"></script>\n");

$doc->setTitle("Modification d'un module");

$doc->openContainer();
$doc->openSideBar();
$doc->buildMenu($me);
$doc->closeSideBar();
$doc->openContent();

$html .= "<h1>Gestion des modules</h1>\n";
$html .= "<p id=\"back-transaction-btn\"><a href=\"admin_modules.php\" class=\"bouton\">Retour liste modules</a></p>\n";
$html .= "<h2>Modification d'un module</h2>\n";
$html .= "<form action=\"" . WEBSITE_SSL . "/admin/modules/admin_module_edit_handler.php\" method=\"post\" name=\"form\" onsubmit=\"javascript:return validateForm(" . $zeModule->getValidationTrio('status') . ");\">\n";
$html .= "<input type=\"hidden\" name=\"id\" value=\"" . $zeModule->getId() . "\" />\n";
$html .= "<div class=\"data_table\">\n";
$html .= "<table class=\"data\">\n";
$html .= " <tr>\n";
$html .= "  <td class=\"td-register\">Nom&nbsp;:</td>\n";
$html .= "  <td class=\"td-input\">" . htmlspecialchars($zeModule->get("name")) . "</td>\n";
$html .= " </tr>\n";
$html .= " <tr>\n";
$html .= "  <td class=\"td-register\">Description&nbsp;:</td>\n";
$html .= "  <td class=\"td-input\">" . htmlspecialchars($zeModule->get("description")) . "</td>\n";
$html .= " </tr>\n";
$html .= " <tr>\n";
$html .= "  <td class=\"td-register\">tat&nbsp;:</td>\n";
$html .= "  <td class=\"td-input\">\n";

$html .= $doc->getHTMLSelect("status", $zeModule->get("statusTypes"), $zeModule->get("status"));

$html .= "  </td>\n";
$html .= " </tr>\n";
$html .= "</table>\n";
$html .= "</div>\n";

//! On rcupre la liste des paramtres du modules dans le tableau module_params
$module_params = $zeModule->getModuleParams();
 $tr_style = "alternate1";
if (count($module_params)>0) {
  //! Le module a un ou plusieurs paramtres, on affiche la table des paramtres
 

  $html .= "<h2>Modification/Suppression des param&egrave;tres</h2>\n";
  $html .= "<div class=\"data_table\">\n";
  $html .= "<table class=\"data\">\n";
  $html .= "<tr>\n";
  $html .= "  <th class=\"data\">Suppression</th>\n";
  $html .= "  <th class=\"data\">Nom du param&egrave;tre</th>\n";
  $html .= "  <th class=\"data\">Valeur du param&egrave;tre</th>\n";
  $html .= "  <th class=\"data\">Description du param&egrave;tre</th>\n";
  $html .= "</tr>\n";

  foreach ($module_params as $param) {
	$html .= "<tr class=\"" . $tr_style . "\">\n";
	$html .= "  <td class=\"td-input\"><input type=\"hidden\" name=\"param_id[]\" value=\"" . $param["id"] . "\"/><input type=\"checkbox\" name=\"param_to_suppr[]\" value=\"".$param["id"]."\" /></td>";
	$html .= "  <td class=\"td-input\"><input type=\"text\" name=\"param_name[]\" value=\"" . htmlspecialchars($param["name"]) . "\" /></td>\n";
	$html .= "  <td class=\"td-input\"><input type=\"text\" size=\"15\" maxlength=\"70\" name=\"param_value[]\" value=\"" . htmlspecialchars($param["value"]) . "\" /></td>\n";
	$html .= "  <td class=\"td-input\"><input type=\"text\" size=\"40\" maxlength=\"70\" name=\"param_description[]\" value=\"" . htmlspecialchars($param["description"]) . "\" /></td>\n";
	$html .= "</tr>\n";
	$tr_style = ($tr_style == "alternate1") ? "alternate2" : "alternate1";
  }
  $html .= "</table>\n";
  $html .= "</div>\n";
}

$html .= "<h2>Ajout d'un param&egrave;tre</h2>\n";
$html .= "<div class=\"data_table\">\n";
$html .= "<table class=\"data\">\n";
$html .= "<tr>\n";
$html .= "  <th class=\"data\">Nom du param&egrave;tre</th>\n";
$html .= "  <th class=\"data\">Valeur du param&egrave;tre</th>\n";
$html .= "  <th class=\"data\">Description du param&egrave;tre</th>\n";
$html .= "</tr>\n";
$html .= "<tr class=\"".$tr_style."\">\n";
$html .= "  <td class=\"td-input\"><input type=\"text\" name=\"new_param_name\" /></td>\n";
$html .= "  <td class=\"td-input\"><input size=\"15\" maxlength=\"70\" type=\"text\" name=\"new_param_value\" /></td>\n";
$html .= "  <td class=\"td-input\"><input size=\"40\" maxlength=\"70\" type=\"text\" name=\"new_param_description\" /></td>\n";
$html .= "</tr>\n";
$html .= "</table>\n";
$html .= "</div>\n";
$html .= "<br />\n";
$html .= "<center><input type=\"submit\" class=\"submit_button\" value=\"";
$html .= "Valider les modifications";
$html .= "\" /></center>\n";
$html .= "</form>\n";
$html .= "</div>\n";

$doc->addBody($html);

$doc->closeContent();
$doc->closeContainer();

$doc->buildFooter();

$doc->display();
?>