<?php
require_once ("../../../config/config.php");
require_once (SITEROOT . '/class/include.class.php');
require_once (SITEROOT . '/public.ssl/modules/actes/class/ActesBatch.class.php');

// Instanciation du module courant
$module = new Module();
if (!$module->initByName("actes")) {
  $_SESSION["error"] = "Erreur d'initialisation du module";
  header("Location: " . WEBSITE_SSL);
  exit ();
}

$me = new User();

if (!$me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit ();
}

if (!$module->isActive() || !$me->canAccess($module->get("name"))) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit ();
}

$myAuthority = new Authority($me->get("authority_id"));

$zeBatch = new ActesBatch();

$batchesList = $zeBatch->getBatchesListForUser($me->getId());

$doc = new HTMLLayout();

$js = "<script type=\"text/javascript\">\n";
$js .= "  function redirect_to_create_form(select_form) {\n";
$js .= "    batch_file_id = select_form.options[select_form.selectedIndex].value;\n";
$js .= "    document.location='" . WEBSITE_SSL . "/modules/actes/actes_transac_add.php?batchfile=' + batch_file_id;\n";
$js .= "  }\n";
$js .= "</script>\n";

$doc->addHeader($js);

$doc->setTitle("Tedetis : Traitement par lots module actes");

$doc->openContainer();
$doc->openSideBar();
$doc->buildMenu($me);
$doc->buildPager($zeBatch);
$doc->closeSideBar();
$doc->openContent();

$html .= "<h1>ACTES - Traitement par lots</h1>\n";
$html .= "<p id=\"back-transaction-btn\"><a class=\"btn btn-default\" href=\"" . WEBSITE_SSL . "/modules/actes/\" class=\"bouton\">Retour liste transactions</a></p>\n";
if (! $me->isSuper() && $me->canEdit($module->get('name'))) {
  $html .= "<div id=\"actions_area\">\n";
  $html .= "<h2>Actions</h2>\n";
  $html .= "<a class=\"btn btn-primary\" href=\"" . WEBSITE_SSL . "/modules/actes/actes_batch_add.php\">Crer un nouveau lot</a>\n";
  $html .= "</div>\n";
}

$html .= "<h2>Liste des lots de transactions</h2>\n";

if (is_array($batchesList) && count($batchesList) > 0) {
  $html .= "<div id=\"lot-area\">\n";
  $html .= "<table class=\"data-table table table-striped\" summary=\"Ce tableau prsente respectivement un lien vers le dtail, une description, la date, le nombre de fichiers non traits et un lien vers les actions disponibles de chaque lot\">";
  $html .= "<caption>Liste des lots de transactions<caption>\n";
  $html .= "<thead>\n";
  $html .= "<tr>\n";
  $html .= " <th id=\"lot\" class=\"data\">Lot</th>\n";
  $html .= " <th id=\"description\" class=\"data\">Description</th>\n";
  $html .= " <th id=\"date\" class=\"data\">Date de cration</th>\n";
  $html .= " <th id=\"file-remaining\" class=\"data\">Fichiers restants</th>\n";
  $html .= " <th id=\"treatment\" class=\"data\">Traiter le fichier&nbsp;:</th>\n";
  $html .= "</tr>\n";
  $html .= "</thead>\n";
  $html .= "<tbody>\n";

  $i = 0;

  foreach ($batchesList as $batchData) {
	$batch = new ActesBatch($batchData["id"]);
	$batch->init();

	$html .= "<tr class=\"alternate" . ($i + 1) . "\">\n";
	$html .= " <td headers=\"lot\"><a href=\"" . WEBSITE_SSL . "/modules/actes/actes_batch_show.php?id=" . $batch->getId() . "\" title=\"Visualiser les dtails du lot n" . $batch->getId() . "\">" . htmlspecialchars($batch->getId()) . "</a></td>\n";
	$html .= " <td headers=\"description\">" . htmlspecialchars($batch->get("description")) . "</td>\n";
	$html .= " <td headers=\"date\">" . Helpers::getDateFromBDDDate($batch->get("submission_date"), true) . "</td>\n";
	$html .= " <td headers=\"file-remaining\">" . $batch->getUnprocessedFilesCount() . "</td>\n";
	$html .= " <td  headers=\"treatment\" class=\"long_field\">";

	if ($batch->getUnprocessedFilesCount() > 0) {
	  $html .= $doc->getHTMLSelect("batch_files", $batch->getUnprocessedFilesIdName(), null, " onchange=\"javascript:redirect_to_create_form(this);\"");
	} else {
	  $html .= "<form action=\"" . WEBSITE_SSL . "/modules/actes/actes_batch_delete.php\" onsubmit=\"return confirm('Voulez-vous vraiment supprimer dfinitivement ce lot ?')\" method=\"post\">\n";
	  $html .= "<p>Tous les fichiers sont traits&nbsp;:\n";
	  $html .= "<input type=\"hidden\" name=\"id\" value=\"" . $batch->getId(). "\" />\n";
	  $html .= "<input type=\"submit\" value=\"Supprimer le lot\" />\n";
	  $html .= "</p></form>\n";
	}

	$html .= "</td>\n";
	$html .= "</tr>\n";
	
	$i = ($i + 1) % 2;
  }
  $html .= "</tbody>\n";
  $html .= "</table>\n";
  $html .= "</div>\n";
} else {
  $html .= "Pas de lot trouv.";
}

$doc->addBody($html);

$doc->closeContent();
$doc->closeContainer();

$doc->buildFooter();
$doc->display();
