<?php

require_once("../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');
require_once(SITEROOT . '/public.ssl/modules/actes/class/ActesEnvelope.class.php');
require_once(SITEROOT . '/public.ssl/modules/actes/class/ActesClassification.class.php');

// Instanciation du module courant
$module = new Module();
if (! $module->initByName("actes")) {
  echo "KO\nErreur d'initialisation du module";
  exit();
}

$me = new User();

if (! $me->authenticate()) {
  echo "KO\nchec de l'authentification";
  exit();
}

if ($me->isGroupAdminOrSuper() || ! $module->isActive() || !$me->canEdit($module->get("name"))) {
  echo "KO\nAccs refus";
  exit();
}

$myAuthority = new Authority($me->get("authority_id"));

// Recuperation des variables du GET
$transId = Helpers::getVarFromGet("transaction");
$transUniqueId = Helpers::getVarFromGet("unique_id");

if(isset($transUniqueId) && ! empty($transUniqueId)){
	$transId = ActesTransaction::getTransactionFromUniqueId($transUniqueId);	
}


if (isset($transId) && ! empty($transId)) {
	$zeTrans = new ActesTransaction();
	$zeTrans->setId($transId);
} else {
	echo "KO\nNumro de transaction invalide.";
	exit();
}

if ($zeTrans->init()) {
	$owner = new User($zeTrans->get("user_id"));
	$owner->init();
} else {
	echo "KO\nNumro de transaction invalide.";
	exit();
  }

$zeEnv = new ActesEnvelope($zeTrans->get("envelope_id"));
if (! $zeEnv->init()) {
  echo "KO\nEnveloppe invalide.";
  exit();
}

// Vrification des permissions
if (! $me->isSuper()) {
  if (! ($me->isAdmin() && $me->get("authority_id") == $owner->get("authority_id")) && ! ($me->getId() == $zeEnv->get("user_id") && $me->canAccess($module->get("name")))) {
	echo "KO\nAccs refus";
	exit();
  }
}

// Rcupration statut
$status = $zeTrans->getCurrentStatus();
if ($status !== false) {
  echo "OK\n" . $status . "\n";
  echo $zeTrans->getFluxRetour($status);
} else {
  echo "KO\nErreur consultation statut.";
}
