<?php 
/*
 * Ce script affiche toutes les informations trouv dans une
 * archive au format ACTES.
 * 
 * Si une erreur est dtct, elle est affich  la fin des 
 * informations
 * 
 * 
 * Usage : archive_actes.php archive_actes.tar.gz
 * 
 * Code retour :
 * 				- 0 : l'enveloppe est conforme
 * 				- -1 : erreur de paramtre
 * 				- -2 : l'enveloppe n'est pas conforme
 *
 */

require_once( __DIR__."/../../init/init.php");

define("TMP_PATH","/tmp/");

function sortir2($message,$code_erreur = -1){
	echo $message.PHP_EOL;
	exit($code_erreur);
}

if ($argc != 2){
	sortir2("Usage:\n {$argv[0]} archive_actes.tar.gz\nou\n{$argv[0]} repository");
}

$archive_path = $argv[1];

echo "Analyze de $archive_path\n";

$envelopeFile = new EnvelopeFile(__DIR__."/../../xsd/actesv1_1.xsd");

$infoEnvelope = $envelopeFile->getInfo($archive_path);
if (! $infoEnvelope ){
	sortir2("L'archive n'est pas conforme : " . $envelopeFile->getLastError(),-2);
}

print_r($infoEnvelope);


sortir2("L'archive est conforme",0);




