<?php

require_once ("../../../config/config.php");
require_once (SITEROOT . '/class/include.class.php');
require_once (SITEROOT . '/public.ssl/modules/helios/class/HeliosRetour.class.php');
// Instanciation du module courant
$module = new Module();
if (!$module->initByName("helios")) {
  $_SESSION["error"] = "Erreur d'initialisation du module";
  header("Location: " . WEBSITE_SSL);
  exit ();
}

$me = new User();

if (!$me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit ();
}

if (!$module->isActive() || !$me->canAccess($module->get("name"))) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit ();
}

$HR = new HeliosRetour();

$fstatus = Helpers :: getVarFromGet("status");
$fmin_submission_date = Helpers :: getVarFromGet("min_submission_date");
$fmax_submission_date = Helpers :: getVarFromGet("max_submission_date");
$fnum = Helpers :: getVarFromGet("num");
$fauthority = Helpers :: getVarFromGet("authority");

$filter = array ();
// Construction chaine de filtrage
//filtre sur tat
if (isset ($fstatus) && is_numeric($fstatus) && $fstatus != 2) {//si = 2 : tous les tats
   $filter[] .= "status = $fstatus";
}

//collectivit (si sadmin)
if (!$me->isSuper()) { // Le super utilisateur voit les reponses de toutes les collectivit
   // Un utilisateur ne voit que les reponses de sa collectivit
  $filter[] .= "helios_retour.authority_id='" . $me->get('authority_id'). "'";
}else {
  if (isset($fauthority) && !empty($fauthority) )
  	$filter[] .= "helios_retour.authority_id='" . $fauthority . "'";
}
// On ajoute les filtres relatifs aux dates
if (isset ($fmin_submission_date) && !empty ($fmin_submission_date)) {
  $filter[] .= "date >= '" . addslashes($fmin_submission_date) . "'";
}
if (isset ($fmax_submission_date) && !empty ($fmax_submission_date)) {
  $filter[] .= "date <= '" . addslashes($fmax_submission_date) . "'";
}
//on ajoute filtre sur nom fichier
if (isset ($fnum) && !empty ($fnum)) {
  $filter[] .= "filename LIKE '%" . addslashes($fnum) . "%'";
}

$where = "";
if (count($filter) > 0) {
  $where = " WHERE " . implode($filter, " AND ");
}


$etat = array(
		0 => "non lu",
		1 => "lu"
		);

$envelops=$HR->getDocumentList($where);

$doc = new HTMLLayout();
$doc->addHeader("<script src=\"/javascript/date-picker.js\" type=\"text/javascript\"></script>\n");
$doc->addHeader("<link rel=\"stylesheet\" type=\"text/css\" href=\"/custom/styles/date-picker.css\" />");

$doc->addHeader('<script type="text/javascript" src="/javascript/jfu/js/jquery.min.js"></script>');
$doc->addHeader('<script type="text/javascript" src="/javascript/zselect.js"></script>');
$doc->addHeader('<script type="text/javascript" src="/javascript/zselect_s2low.js"></script>');


$doc->setTitle("Module helios : message retour ");

$doc->openContainer();
$doc->openSideBar();
$doc->buildMenu($me);
$doc->buildPager($HR);
$doc->closeSideBar();
$doc->openContent();

$html = "<h1>Helios - Dmatrialisation de documents financiers</h1>\n";

  if ($module->getParam("paper") == "on") {
    $html .= "<p>Le systme est actuellement en mode &nbsp;papier&nbsp;. Dans ce mode il est impossible de crer de nouvelle transaction. Les transferts doivent se faire par les moyens classiques.</p>\n";
  } else {
    $html.="<p id=\"back-user-btn\"><a href=\"".WEBSITE_SSL. "/modules/helios/index.php\" class=\"btn btn-default\" title=\"afficher la liste des transactions\">Retour liste transactions</a></p>\n";
  }

//filtrage aria
$html .= "<h2 class=\"toggle_title\" onclick=\"javascript:toggle_visibility('filtering_area');\">Filtrage</h2>\n";
$html .= "<div id=\"filtering_area\">\n";
$html .= "<form class=\"form-horizontal\" action=\"" . WEBSITE_SSL . "/modules/helios/helios_retour.php\" method=\"get\">\n";

if (empty($fstatus)) $fstatus = 0; //par defaut tat selectionne

$html .= "<div class=\"form-group\">\n";
$html .= "<label class=\"col-md-3 control-label\" for=\"status\">Etat</label>\n";
$html .= "<div class=\"col-md-3\">" . $doc->getHTMLSelect("status", array(0 => "non lu", 1 => "lu", 2 => "tous les tats"), $fstatus) . "</div>\n";
$html .= "<label class=\"col-md-3 control-label\" for=\"filename-contain\">Le nom de fichier contient</label>";
$html .= "<div class=\"col-md-3\"><input id=\"filename-contain\" class=\"form-control\" type=\"text\" name=\"num\" size=\"20\" maxlength=\"25\"";

//$fnum: le nom du fichier contient...
if (strlen($fnum) > 0) {
  $html .= " value=\"" . $fnum . "\"";
}

$html .= " /></div>\n</div>\n";

//des autres options...
//les dates
//date minimale de postage
$html .= "<div class=\"form-group\">\n";
$html .= "<label class=\"col-md-3\" for=\"min_submission_date\">Date de rception minimale</label>\n";
$html .= "<div class=\"col-md-3\"><input id=\"min_submission_date\" name=\"min_submission_date\" type=\"hidden\" value=\"" . get_hecho($fmin_submission_date) . "\"/>\n";
$html .= "    <script type=\"text/javascript\">\n";
$html .= "    //<![CDATA[\n";
$html .= "    obj_min_submission_date = new DatePicker('min_submission_date', 'fr');\n";
$html .= "    //]]>\n";
$html .= "    </script>\n";

$html .= "    <a href=\"#datepicker\" id=\"datepicker_min_submission_date_link\" class=\"datepicker_link\" onclick=\"javascript:obj_min_submission_date.toggleDatePicker(); return false;\">";

if ($fmin_submission_date) {
  setlocale(LC_TIME, "fr_FR.ISO-8859-15@euro");
  $html .= strftime("%e %B %Y", Helpers :: ansiDateToTimestamp($fmin_submission_date));
} else {
  $html .= "Choisir une date";
}
$html .= "</a>\n";
$html .= "    <div class=\"date_picker\" style=\"display: none;\" id=\"datepicker_min_submission_date_calendar\"></div></div>\n";

$html .= "<label class=\"col-md-3\" for=\"max_submission_date\">Date de rception maximale</label>\n";
$html .= "<div class=\"col-md-3\"><input id=\"max_submission_date\" name=\"max_submission_date\" type=\"hidden\" value=\"" . get_hecho($fmax_submission_date) . "\"/>\n";
$html .= "    <script type=\"text/javascript\">\n";
$html .= "    //<![CDATA[\n";
$html .= "    obj_max_submission_date = new DatePicker('max_submission_date', 'fr');\n";
$html .= "    //]]>\n";
$html .= "    </script>\n";

$html .= "    <a href=\"#datepicker\" id=\"datepicker_max_submission_date_link\" class=\"datepicker_link\" onclick=\"javascript:obj_max_submission_date.toggleDatePicker(); return false;\">";

if ($fmax_submission_date) {
  setlocale(LC_TIME, "fr_FR.ISO-8859-15@euro");
  $html .= strftime("%e %B %Y", Helpers :: ansiDateToTimestamp($fmax_submission_date));
} else {
  $html .= "Choisir une date";
}
$html .= "</a>\n";
$html .= "    <div class=\"date_picker\" style=\"display: none;\" id=\"datepicker_max_submission_date_calendar\"></div></div>\n</div>\n";


//colectivitvit  pour superuser
if ($me->isSuper()) {

    ob_start();
    ?>
    <div class="form-group">

        <label for="authority" class="col-md-3 control-label">Collectivit</label>

        <div class="col-md-3">
            <select class="form-control zselect_authorities" name="authority">
                <option value="">Toutes</option>
                <?php foreach ($me->getAllPossibleAuthority() as $key => $val) : ?>
                    <option
                        value="<?php hecho($key) ?>" <?php echo (strcmp($key, $fauthority) == 0) ? " selected='selected'" : ""; ?>>
                        <?php hecho($val) ?>
                    </option>
                <?php endforeach; ?>
            </select>
        </div>
    </div>
    <?php
    $html .= ob_get_contents();
    ob_end_clean();

    /*$html .= "<div class=\"form-group\">\n";
	$html .= "<label class=\"col-md-3 control-label\" for=\"authority\">Collectivit</label>\n";
	$cond = " ORDER BY authorities.name ASC";
	$html .= "<div class=\"col-md-3\">" . $doc->getHTMLSelect("authority", Authority :: getAuthoritiesIdName( " ORDER BY authorities.name ASC"), $fauthority) . "</div>\n</div>\n";*/


}
$html .= "<div class=\"form-group\">";
$html .= "    <button type=\"submit\" class=\"col-md-offset-3 col-md-3 btn btn-default\">Filtrer</button>";
$html .= "    <a href=\"" . WEBSITE_SSL . "/modules/helios/helios_retour.php\" class=\"col-md-offset-3 col-md-3 btn btn-default\">Remise zro</a>";
$html .= "</div>";

$html .= "</form>\n";
$html .= "</div>\n"; //filtrage aria

$html .= "<h2>Liste des messages retours</h2>\n";

if (count($envelops) > 0) {
    $html .= "<div id=\"retours-area\">\n";
    $html .= "<table class=\"data-table table table-striped\" summary=\"Ce tableau prsente respectivement le nom de fichier, la date, l'tat, et un lien vers les actions disponibles de chaque message retour Helios\">\n";
    $html .= " <caption>Liste des messages retours Helios en fonction des choix de filtrage</caption>\n";
    $html .= " <thead>\n";
    $html .= " <tr>\n";
    $html .= "  <th>Nom du fichier</th>\n";
    $html .= "  <th>Date de rception</th>\n";
    $html .= "  <th>tat</th>\n";
    $html .= "  <th>Action</th>\n";
    $html .= " </tr>\n";
    $html .= " </thead>\n";
    $html .= " <tbody>\n";
	 	foreach ($envelops as $envelope) {
	  
	      $retour_id = $envelope["id"];
	
	      $html .= "<tr>\n";
	      $html .= " <td> <a href=\"" .WEBSITE_SSL. "/modules/helios/helios_download_response.php?id=" .$retour_id. "\" title=\"Tlcharger l'acquittement\">".$envelope["filename"]."</a> </td> \n";
	      $html .= " <td>" . Helpers::getDateFromBDDDate($envelope["date"], true)."</td>\n";
	      $html .= " <td>" . $etat[$envelope["status"]]."</td>\n";
	      $html .= " <td> ";
	      if ($envelope["status"] == 0 && !$me->isSuper())
	      	$html .= "<a href=\"" . WEBSITE_SSL . "/modules/helios/helios_change_status_retour.php?id=" .$retour_id. "\" title=\"passer  l'tat lu\" class=\"icon\"> <img alt=\"ok\" src=\"../../custom/images/icone_ok.gif\"> </a> ";
	      $html .= "</td>\n";
	      $html .= "</tr>\n";
		}
	$html .= "</tbody>\n";
	$html .= "</table>\n";
        $html .= "</div>\n";
}else{
	$html .= "Pas de transaction trouve correspondant aux critres de filtrage.";
}


$doc->addBody($html);

$doc->closeContent();
$doc->closeContainer();

$doc->buildFooter();

$doc->display();