<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant   la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,    l'utilisation,    la modification et/ou au
 * dveloppement et   la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe   
 * manipuler et qui le rserve donc   des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits   charger  et  tester  l'adquation  du
 * logiciel   leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file admin_user_delete.php
 * \brief Page effectuant la suppression d'un utilisateur
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 16.03.2006
 * 
 *
 * Cette page supprime un utilisateur de la base de donnes
 * Elle prend un paramtre id dans la requte HTTP POST designant
 * l'utilisateur  supprimer.
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *  JS   19.07.2006  Adaptation pour Tedetis
 */

// Configuration
require_once("../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');

// Suppression utilisateur dsactive
header("Location: " . WEBSITE);

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if (! $me->isAdmin()) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$id = isset($_POST["id"]) ? $_POST["id"] : null;

if (isset($id) && ! empty($id)) {
  $him = new User($id);

  if (! $me->canEditUser($id)) {
	$_SESSION["error"] = "Accs refus pour la suppression de cet utilisateur";
	header("Location: " . WEBSITE_SSL . "/admin/users/admin_users.php");
	exit();
  } else {
	if ($him->delete()) {
	  $msg = "Suppression de l'utilisateur " . $him->getPrettyName() . ". Rsultat ok.";
	  if (! Log::newEntry(LOG_ISSUER_NAME, $msg, 1, false, $me->get("role"), false, $me)) {
		$msg .= "\nErreur de journalisation.";
	  }
	
	  $_SESSION["error"] = nl2br($msg);
	  header("Location: " . WEBSITE_SSL . "/admin/users/admin_users.php");
	  exit();
	} else {
	  $msg = "Erreur lors de la tentative de suppression de l'utilisateur\n" . $him->getErrorMsg();
	  if (! Log::newEntry(LOG_ISSUER_NAME, $msg, 3, false, $me->get("role"), false, $me)) {
		$msg .= "\nErreur de journalisation.";
	  }
	
	  $_SESSION["error"] = nl2br($msg);
	  header("Location: " . WEBSITE_SSL . "/admin/users/admin_users.php");
	  exit();
	}
  }
} else {
  $_SESSION["error"] = "Pas d'identifiant utilisateur spcifi";
  header("Location: " . WEBSITE_SSL . "/admin/users/admin_users.php");
  exit();
}
?>