<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 *
 * contact@alternancesoft.com
 *
  * Ce logiciel est un programme informatique servant  la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,   l'utilisation,   la modification et/ou au
 * dveloppement et  la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe  
 * manipuler et qui le rserve donc  des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits  charger  et  tester  l'adquation  du
 * logiciel  leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
/**
 * \class mail_annuaire  mail_annuaire.class.php
 * \brief Cette classe permet de modeliser le tableau correspond de mail_annuraire
 * 
 * \author TH ,JMontiel
 * \date :23-04-2008
 * 
 *
 * Cette classe fournit des mthodes de traiter le tableau mail_annuaire
 * Modifications :
 * Auteur   Date       Commentaire
 *
 */

require_once(SITEROOT . "/class/DataObject.class.php");
class mail_annuaire extends DataObject
{
	
	protected $objectName="mail_annuaire";
	protected $id;
	protected $user_id;
	protected $mail_address;
	protected $description;
	
	protected $dbFields =  array(
	"authority_id"      	=> array( "descr" => "Identifiant mail", "type" => "isInt", "mandatory" => true),
	"mail_address"  => array("descr" =>"---", "type" =>"isString", "mandatory"=>true),
	"description"  	=> array("descr" =>"---", "type" =>"isString", "mandatory"=>true),
	);	
	
	function __construct($id=false)
  	{
    	parent::__construct($id);
  	}
  	
  	public function newSave($address,$authority_id,$description)
  	{
  		$this->mail_address=$address;
  		$this->authority_id=$authority_id;
  		$this->description=$description;
  		parent::save(false);
    	return true;
  	}
  	
	public function getId()
	{
		return $this->id;
	}
	
	public function getAuthority_id()
	{
		return $this->authority_id;
	}
	
	public function getMailAddress()
	{
		return $this->mail_address;
	}
	
	public function getDescription()
	{
		return $this->description;
	}
	
	public function getMail()
	{
		return $this->mail_address."-".$this->description;
	}
}
	