<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant   la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,    l'utilisation,    la modification et/ou au
 * dveloppement et   la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe   
 * manipuler et qui le rserve donc   des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits   charger  et  tester  l'adquation  du
 * logiciel   leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file install_handler.php
 * \brief Page de traitement de l''initialisation du site Tedetis
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 19.08.2006
 * 
 *
 * Page de traitement de l'initialisation du site TDTis (non authentifi).
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *
 */


// Configuration
require_once("../config/config.php");
require_once(SITEROOT . '/class/include.class.php');

// Vrification si l'application est dj configure ou pas
if (User::dbHasUser()) {
  $_SESSION["error"] = "L'application est dj configure.";
  header("Location: " . WEBSITE);
  exit();
}

// Rcupration des variables du POST
$name = Helpers::getVarFromPost("name", true);
$givenname = Helpers::getVarFromPost("givenname", true);
$email = Helpers::getVarFromPost("email", true);
$telephone = Helpers::getVarFromPost("telephone", true);
$certificate = $_FILES["certificate"];

$him = new User();

$him->set("name", $name);
$him->set("givenname", $givenname);
$him->set("email", $email);
$him->set("telephone", $telephone);
$him->set("status", 1);
$him->set("authority_id", 1);
$him->set("role", 'SADM');

if (is_array($certificate) && count($certificate) > 0 && is_uploaded_file($certificate["tmp_name"])) {
  $him->set("certFilePath", $certificate["tmp_name"]);
} else {
  $_SESSION["error"] = "Le certificat utilisateur est obligatoire<br />";
  header("Location: " . WEBSITE . "/install.php");
  exit();
}

if (! $him->save()) {
  $_SESSION["error"] = "Erreur lors de l'enregistrement de l'utilisateur :<br />" . $him->getErrorMsg();
  header("Location: " . WEBSITE . "/install.php");
  exit();
} else {
  Helpers::purgeTempSession();
  $_SESSION["error"] = "Utilisateur cr avec succs";
  header("Location: " . WEBSITE);
  exit();
}
?>
