<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant   la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,    l'utilisation,    la modification et/ou au
 * dveloppement et   la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe   
 * manipuler et qui le rserve donc   des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits   charger  et  tester  l'adquation  du
 * logiciel   leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file admin_user_download_cert.php
 * \brief Page de tlchargement du certificat utilisateur
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 20.03.2006
 * 
 *
 * Cette page permet de tlcharger le certificat d'un utilisateur
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *  JS   27.07.2006  Adaptation pour Tedetis
 */


// Configuration
require_once("../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');
require_once(SITEROOT . '/class/Helpers.class.php');

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if (! $me->isAdmin()) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}

if (isset($_SESSION['certifpath'])) {
  $f = fopen($_SESSION['certifpath'], "rb");
  if ($f == false) {
    $_SESSION["error"] = "Impossible de tlcharger le certificat";
	header("Location: " . WEBSITE_SSL);
    exit();
  }

  $content_len = (int) filesize($_SESSION['certifpath']);
  $content_file = fread($f, $content_len);
  fclose($f);
  
  $output_file = basename($_SESSION['certifpath']);
  
  @ob_end_clean();
  @ini_set('zlib.output_compression', 'Off');
  header('Pragma: public');
  
  header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
  header('Cache-Control: no-store, no-cache, must-revalidate'); // HTTP/1.1
  header('Cache-Control: pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
  header('Content-Transfer-Encoding: none');
  header('Content-Type: application/octetstream; name="' . $output_file . '"'); //This should work for IE & Opera
  header('Content-Type: application/octet-stream; name="' . $output_file . '"'); //This should work for the rest
  header('Content-Disposition: attachment; filename="' . $output_file . '"');
  header("Content-length: $content_len");
  
  echo $content_file;
  exit();
} else {
  header("Location: " . WEBSITE_SSL);
  exit();
}
?>