<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant  la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,   l'utilisation,   la modification et/ou au
 * dveloppement et  la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe  
 * manipuler et qui le rserve donc  des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits  charger  et  tester  l'adquation  du
 * logiciel  leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file actes_admin_window_edit_handler.php
 * \brief Page de traitement des modifications ou ajout des fentres
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 23.08.2006
 * 
 *
 * Cette page effectue le traitement d'ajout ou de modification d'une
 * fentre de transmission dans la base de donnes
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *
 */

// Configuration
require_once("../../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');
require_once(SITEROOT . '/public.ssl/modules/actes/class/ActesTransmissionWindow.class.php');

// Instanciation du module courant
$module = new Module();
if (! $module->initByName("actes")) {
  $_SESSION["error"] = "Erreur d'initialisation du module";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if (! $me->isSuper() || ! $module->isActive()|| ! $me->canAccess($module->get("name"))) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}

// Rcupration des variables du POST
$id = Helpers::getVarFromPost("id");
$window_start_date = Helpers::getVarFromPost("window_start_date", true);
$window_start_hour = Helpers::getVarFromPost("window_start_hour", true);
$window_end_date = Helpers::getVarFromPost("window_end_date", true);
$window_end_hour = Helpers::getVarFromPost("window_end_hour", true);
$rate_limit = Helpers::getVarFromPost("rate_limit", true);

// Mode modification ou pas
$zeWin = new ActesTransmissionWindow();
$mod = false;

if (isset($id) && ! empty($id)) {
  $zeWin->setId($id);
  if (! $zeWin->init()) {
    $_SESSION["error"] = "Erreur lors de la modification de la fentre.";
    header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_windows.php");
    exit();
  } else {
	$mod = true;
  }
}

$window_start_stamp = ActesTransmissionWindow::roundDate($window_start_date, $window_start_hour);
$window_end_stamp = ActesTransmissionWindow::roundDate($window_end_date, $window_end_hour);

// Contrle si la date de fin est antrieure  la date de dbut
if ($window_start_stamp > $window_end_stamp) {
  $_SESSION["error"] = "La date de fin est antrieure  la date de dbut.";
  if ($zeWin->isNew()) {
	header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_window_edit.php");
  } else {
	header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_window_edit.php?id=" . $zeWin->getId());
  }
  exit();
}

$zeWin->set("window_start_stamp", $window_start_stamp);
$zeWin->set("window_end_stamp", $window_end_stamp);
$zeWin->set("rate_limit", $rate_limit);

if (($id = $zeWin->hasCollision()) !== false) {
  $_SESSION["error"] = "La fentre interfre avec une ou plusieurs fentres dj dfinies&nbsp;:<br />\nFentre numro " . implode(', ', $id);

  if ($zeWin->isNew()) {
	header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_window_edit.php");
  } else {
	header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_window_edit.php?id=" . $zeWin->getId());
  }
  exit();
}

if (! $zeWin->save()) {
  $msg = "Erreur lors de l'enregistrement de la fentre :\n" . $zeWin->getErrorMsg();
  if (! Log::newEntry(LOG_ISSUER_NAME, $msg, 3, false, $me->get("role"), $module->get("name"), $me)) {
	$msg .= "\nErreur de journalisation.";
  }

  $_SESSION["error"] = nl2br($msg);

  if ($zeWin->isNew()) {
	header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_window_edit.php");
  } else {
	header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_window_edit.php?id=" . $zeWin->getId());
  }
  exit();
} else {
  $msg = ($mod) ? "Modification" : "Cration";
  $msg .= " fentre de transmission n" . $zeWin->getId() . ". Rsultat ok.";
  if (! Log::newEntry(LOG_ISSUER_NAME, $msg, 1, false, $me->get("role"), $module->get("name"), $me)) {
	$msg .= "\nErreur de journalisation.";
  }

  $_SESSION["error"] = nl2br($msg);
  Helpers::purgeTempSession();
  header("Location: " . WEBSITE_SSL . "/modules/actes/admin/actes_admin_window_edit.php?id=" . $zeWin->getId());
  exit();
}

?>