<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant  la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,   l'utilisation,   la modification et/ou au
 * dveloppement et  la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe  
 * manipuler et qui le rserve donc  des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits  charger  et  tester  l'adquation  du
 * logiciel  leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file helios_admin_windows.php
 * \brief Page de gestion des fentres de transmission
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 23.08.2006
 * 
 *
 * Cette page permet de grer les fentres de transmission vers le ministre
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *
 */


// Configuration
require_once("../../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');
require_once(SITEROOT . '/public.ssl/modules/helios/class/HeliosTransmissionWindow.class.php');

// Instanciation du module courant
$module = new Module();
if (! $module->initByName("helios")) {
  $_SESSION["error"] = "Erreur d'initialisation du module";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if (! $me->isSuper() || ! $module->isActive() || ! $me->canAccess($module->get("name"))) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}
$win = new HeliosTransmissionWindow();
$windows = $win->getWindowsList();

$doc = new HTMLLayout();

$doc->setTitle("Gestion des fentres module HELIOS");

$doc->openContainer();
$doc->openSideBar();
$doc->buildMenu($me);
$doc->buildPager($win);
$doc->closeSideBar();
$doc->openContent();

$html = "<h1>Gestion des fentres de transmission</h1>\n";
$html .= "<h2>Actions</h2>\n";
$html .= "<p><a href=\"" . WEBSITE_SSL . "/modules/helios/admin/helios_admin_window_edit.php\" class=\"btn btn-primary\">Ajouter une fentre</a></p>\n";
$html .= "<h2>Liste des fentres existantes</h2>\n";

if (count($windows) > 0) {
  $html .= "<table class=\"data-table table table-striped\" summary=\"\">";
  $html .= "<thead>\n";
  $html .= "<tr>\n";
  $html .= " <th id=\"id\">Numro</th>\n";
  $html .= " <th id=\"start\">Dbut</th>\n";
  $html .= " <th id=\"end\">Fin</th>\n";
  $html .= " <th id=\"rate-limit\">Dbit horaire</th>\n";
  $html .= " <th id=\"actions\">Actions</th>\n";
  $html .= "</tr>\n";
  $html .= "</thead>\n";
  $html .= "</tbody>\n";

  foreach ($windows as $window) {
	$html .= "<tr>\n";
	$html .= " <td headers=\"id\">" . $window["id"] . "</td>\n";
	$html .= " <td headers=\"start\">" . Helpers::getDateFromBDDDate($window["start"], true) . "</td>\n";
	$html .= " <td headers=\"end\">" . Helpers::getDateFromBDDDate($window["end"], true) . "</td>\n";
	$html .= " <td headers=\"rate-limit\">" . $window["rate_limit"] . "</td>\n";
	$html .= " <td headers=\"actions\"><a href=\"" . WEBSITE_SSL . "/modules/helios/admin/helios_admin_window_edit.php?id=" . $window["id"] . "\" class=\"icon\"><img src=\"" . WEBSITE_SSL . "/custom/images/erreur.png\" alt=\"image_modif\" title=\"Modifier\" /></a></td>\n";
	$html .= "</tr>\n";
  }

  $html .= "</tbody>\n";
  $html .= "</table>\n";
} else {
  $html .= "Pas de fentre de transmission dfinie.";
}

$html .= "</div>\n";


$doc->addBody($html);

$doc->closeContainer();

$doc->buildFooter();

$doc->display();

?>
